POJ 3254 (状压DP) Corn Fields

基础的状压DP,因为是将状态压缩到一个整数中,所以会涉及到很多比较巧妙的位运算。

我们可以先把输入中每行的01压缩成一个整数。

判断一个状态是否有相邻1:

如果 x & (x << 1) 非0,说明有相邻的两个1

判断一个状态能否放在该行:

如果 (a[i] & state) != state,说明是不能放置的。因为a[i]中存在某个0和对应state中的1,与运算之后改变了state的值

判断相邻两行的状态是否有同一列相邻的1:

如果(state & _state)不为零,说明有相邻的1

 1 #include <cstdio>
 2 #include <cstring>
 3
 4 const int maxn = 13;
 5 const int M = 100000000;
 6 int a[maxn], d[maxn][1 << maxn];
 7 int n, m, tot;
 8
 9 inline bool check_row(int x) { return x & (x << 1) ? false : true; }    //判断一行是否有相邻的
10 inline bool check_col(int x1, int x2) { return x1 & x2 ? false : true; }    //判断一列是否有相邻的
11 inline bool check_put(int a, int x) { return (x & a) == x ? true : false; } //判断该状态能否放在该行
12
13 int main()
14 {
15     //freopen("in.txt", "r", stdin);
16
17     while(scanf("%d%d", &n, &m) == 2)
18     {
19         memset(d, 0, sizeof(d));
20         for(int i = 0; i < n; i++)
21         {
22             int t;
23             a[i] = 0;
24             for(int j = 0; j < m; j++) { scanf("%d", &t); a[i] = a[i] * 2 + t; }
25         }
26         tot = (1 << m);
27         for(int i = 0; i < tot; i++) if(check_row(i) && check_put(a[0], i)) d[0][i] = 1;
28
29         for(int i = 1; i < n; i++)
30         {//枚举行标
31             for(int state = 0; state < tot; state++)
32             {//枚举该行的状态
33                 if(!check_row(state) || !check_put(a[i], state)) continue;
34                 for(int _state = 0; _state < tot; _state++)
35                 {//枚举上一行的状态
36                     if(state & _state) continue;
37                     d[i][state] = (d[i][state] + d[i-1][_state]) % M;
38                 }
39             }
40         }
41
42         int ans = 0;
43         for(int i = 0; i < tot; i++) ans = (ans + d[n-1][i]) % M;
44         printf("%d\n", ans);
45     }
46
47     return 0;
48 }

代码君

时间: 2024-12-30 16:15:05

POJ 3254 (状压DP) Corn Fields的相关文章

hdu 3254 (状压DP) Corn Fields

poj 3254 n乘m的矩阵,1表示这块区域可以放牛,0,表示不能,而且不能在相邻的(包括上下相邻)两个区域放牛,问有多少种放牛的方法,全部不放也是一种方法. 对于每块可以放牛的区域,有放或者不放两种选择,状压DP,dp[i][j]表示第 i 行以state[j]这种状态的时候和方法取值. 具体的参考http://www.tuicool.com/articles/JVzMVj 写的很详细. 1 #include<cstdio> 2 #include<cstring> 3 #inc

poj 3254 状压dp入门题

1.poj 3254  Corn Fields    状态压缩dp入门题 2.总结:二进制实在巧妙,以前从来没想过可以这样用. 题意:n行m列,1表示肥沃,0表示贫瘠,把牛放在肥沃处,要求所有牛不能相邻,求有多少种放法. #include<iostream> #include<cstring> #include<cmath> #include<queue> #include<algorithm> #include<cstdio> #d

POJ 3254 状压DP

题目大意: 一个农民有一片n行m列 的农场   n和m 范围[1,12]  对于每一块土地 ,1代表可以种地,0代表不能种. 因为农夫要种草喂牛,牛吃草不能挨着,所以农夫种菜的每一块都不能有公共边. 告诉你 n ,m 和那些地方能种菜哪些地方不能种菜,求农夫一共有多少种方案种菜 解法: 基本思想是状压 也就是用一个int 型的数代表一行的种菜策略,二进制的0代表该位不能种菜,1位代表能种菜,使用位运算使处理速度变快 对于单行行,最多有2^12 种情况,并且 2^12种情况里面还有很多不满足题意的

Corn Fields(POJ 3254状压dp)

题意: n*m网格1能放0不能放 放的格子不能相邻 求一共多少种可放的方案. 分析: dp[i][j]第i行可行状态j的的最大方案数,枚举当前行和前一行的所有状态转移就行了(不放牛也算一种情况) #include <map> #include <set> #include <list> #include <cmath> #include <queue> #include <stack> #include <cstdio>

POJ 1038 状压DP

一个公司生产一种2*3规模的芯片,但是原材料上面有一些地方是不能用来当作芯片材料的,给出原料大小,及上面不能做原料的点,问你怎么分解,可以使生成芯片最大化. 对M进行三进制状压 last数组存储第i-1行和i-2行状态,cur数组存储i行和i-1行状态 cur[k]=2; // 本行k位置和上行k位置都不可用 cur[k]=1; // 本行k位置可用,上行k位置不可用 cur[k]=0; // 本行和上行位置k均可用 必须用滚动数组,否则爆内存 #include "stdio.h" #

Best Sequence(poj 1699) 状压dp(TSP)

类似于前两天做的那个wordstack.状压的其实有时候爆搜+记忆化也差不多. 就是这个是要与之前的都重合,移位预处理要注意. 理解好第一个样例就行 /* *********************************************** Author :bingone Created Time :2014/12/9 22:48:56 File Name :a.cpp ************************************************ */ #inclu

POJ 2411 状压DP经典

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 16771   Accepted: 9683 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

POJ 2686(状压DP

第一次做状压感觉那一长串for显示了这是个多么暴力的算法呢...1A了倒是挺顺的 #include<iostream> #include<cstdio> #include<algorithm> #include<queue> #include<utility> #include<vector> #include<cstring> #include<cmath> #define INF 0x3fffffff #d

poj 2923 状压dp+01背包

好牛b的思路 题意:一系列物品,用二辆车运送,求运送完所需的最小次数,两辆车必须一起走 解法为状态压缩DP+背包,本题的解题思路是先枚举选择若干个时的状态,总状态量为1<<n,判断这些状态集合里的那些物品能否一次就运走,如果能运走,那就把这个状态看成一个物品.预处理完能从枚举中找到tot个物品,再用这tol个物品中没有交集(也就是两个状态不能同时含有一个物品)的物品进行01背包,每个物品的体积是state[i],价值是1,求包含n个物品的最少价值也就是dp[(1<<n)-1](dp